#include "config.h"

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>

#include "proto.h"
#include "seven_client.h"
#include "panic.h"

/* arch-tag: 85b95cb3-e43d-4f92-b7d4-9edc68c807e8 */

static void 
client_ls(void)
{
        char *buf;
        asprintf(&buf, "/tmp/seven/%u", (unsigned)getuid());
        DIR *dir = opendir(buf);
        free(buf);
        if(!dir) panicno(buf);
        struct dirent *de = NULL;
        CLIENT *clnt = NULL;
        while((de = readdir(dir))) {
                struct stat stat;
                int ret = asprintf(&buf, "/tmp/seven/%u/%s", getuid(), de->d_name);
                if(ret == -1) 
                        panicno("asprintf");
                if(lstat(buf, &stat) == -1) continue;
                if(!S_ISSOCK(stat.st_mode)) continue;
                clnt = clnt_create(buf, SEVENPROG, SEVENVERS, "unix");
                free(buf);
                //if(!clnt) 
                //        fprintf(stderr, "Cannot connect to %s, is it dead?\n", de->d_name);
                if(clnt) {
                        struct seven_info *si = sproto_getinfo_1(clnt);
                        printf("%s\n", si->name);
                        if(si->connections.connections_len) {   
                                printf("  WINDOWID=0x%x\n", si->connections.connections_val->xwindow);
                                printf("  DISPLAY=%s\n", si->connections.connections_val->display );
                                printf("  XAUTHORITY=%s\n", si->connections.connections_val->xauthority );
                        } else {
                                puts("  (Disconnected)");
                        }
                        printf("  TITLE=%s\n", si->title);
                        printf("  CLASS=%s\n", si->klass);
                        xdr_free((xdrproc_t)xdr_seven_info, (char *)si);
                }
        }
        int ret = closedir(dir);
        if(ret == -1) panicno("closedir");
        if(!clnt) 
                puts("no sevens found!");
}


void
do_client_call(int argc, char *argv[])
{
        client_ls();
}
